#![allow(dead_code)]

mod bit_utilities;

use bit_utilities as bu;
use text_io::read;

fn input_handler() {
    let (mut first_register, mut second_register) = bu::align_registers(
        bu::BasicRegister::new(bu::get_memory("first number")),
        bu::BasicRegister::new(bu::get_memory("second number")),
    );

    // println!();
    // println!("First register:\n{}", first_register.table());
    // println!("Second register:\n{}", second_register.table());

    loop {
        print!("\nChoose the operation:\n[a]ddition, [s]ubtraction, [m]ultiplication, [d]ivision, [q]uit\n>>> ");
        let input: String = read!();
        match input.as_str() {
            "a" => {
                let sum: bu::BasicRegister = bu::binary_sum(&first_register, &second_register);
                println!("Sum:\n{}\nResult (to copy): {sum:b}", sum.table())
            }
            "s" => {
                let difference: bu::BasicRegister =
                    bu::binary_subtraction(&first_register, &second_register);
                println!(
                    "Difference:\n{}\nResult (to copy): {difference:b}",
                    difference.table()
                )
            },
            "m" => loop {
                print!("\nChoose method to use (1-4): ");
                let method_input: String = read!();
                match method_input.as_str() {
                    "1" => {
                        println!("{}", bu::binary_multiplication_method_1(&first_register, &second_register));
                        break;
                    },
                    _ => println!("Not an available operation, try again."),
                }
            },
            "d" => (),
            "q" => std::process::exit(0x0100),
            _ => println!("Not an available operation, try again."),
        }
    }
}

fn main() {
    // let mut reg = bu::BasicRegister::new(bu::get_memory("your number"));
    // let mut reg2 = bu::BasicRegister::new(bu::get_memory("your number"));
    //
    // println!("{reg}");
    // println!("{reg2}");
    // println!("{}", bu::binary_multiplication_method_1(reg, reg2))
    input_handler();
}
